--calc.lua 
--
-- a calculator for VO!
--  By Mad Miner Moda.
--
-- usage: /calc

-- define
CALC = CALC or {}
if not CALC then 
  declare (CALC)
end

CALC.ui = CALC.ui or {}
if not CALC.ui then
  declare (CALC.ui)
end
-- end define


-- variables
CALC.Ver = "1.1"
CALC.BLUE = '0 0 255'
CALC.BLACK = '00 00 00'

CALC.MEMORY = 0
CALC.A = 0
CALC.B = 0
CALC.OPERAND = ''
CALC.CLEAR_DISPLAY = false
CALC.catcher = {}
CALC.CHANGED = false

-- color codes
CALC.ORANGE = '255 165 0'
CALC.GREY82 = '209 209 209'
CALC.GREY65 = '166 166 166'
CALC.GREY60 = '153 153 153'
CALC.GREY40 = '102 102 102'
CALC.GREY20 = '51 51 51'
CALC.BLACK  = '0 0 0'
CALC.NORMAL = '255 255 255'
CALC.YELLOW = '107 142 35'
CALC.RED    = '205 92 92'
CALC.SLATEGREY4 = '108 123 139'
CALC.SLATEGREY2 = '185 211 238'
CALC.SLATEBLUE1 = '131 111 255'
CALC.ROYALBLUE1 = '72 118 255'
CALC.ROYALBLUE4 = '39 64 139'
CALC.SKYBLUE1 = '135 206 255'
CALC.GREEN = '105 139 34'
CALC.TXTBLACK = '\127383838'

-- colors for functions
CALC.FUNCTION_COLORFG = CALC.SLATEGREY2
--CALC.FUNCTION_COLORBG = CALC.SKYBLUE1
CALC.FUNCTION_COLORBG = CALC.SLATEBLUE1

-- color for backspace
CALC.BS_COLORFG = CALC.RED
CALC.BS_COLORBG = CALC.SKYBLUE1

-- color for close button
CALC.CLOSE_COLORFG = CALC.RED
CALC.CLOSE_COLORBG = nil

--colors for numbers
CALC.NUMBER_COLORFG = CALC.SLATEGREY2
CALC.NUMBER_COLORBG = CALC.GREY40

-- colors for basic - + * / functions
CALC.OPERAND_COLORFG = CALC.NORMAL
CALC.OPERAND_COLORBG = CALC.SKYBLUE1

-- colors for scientific/trig functions
CALC.SCI_COLORFG = CALC.SLATEGREY2
--CALC.SCI_COLORBG = CALC.SKYBLUE1
CALC.SCI_COLORBG = CALC.SLATEBLUE1

--colors for equal/enter button
CALC.EQUAL_COLORFG = CALC.NORMAL
CALC.EQUAL_COLORBG = CALC.GREY20

-- color for memory buttons
CALC.MEMORY_COLORFG = CALC.SLATEGREY2
CALC.MEMORY_COLORBG = CALC.SLATEBLUE1

-- colors for clear buttons
CALC.CLEAR_COLORFG = CALC.RED
CALC.CLEAR_COLORBG = CALC.SKYBLUE1
-- end variables


-- ui elements
CALC.ui.DISPLAY = iup.label {title = '0', 
  EXPAND='YES',ALIGNMENT='ARIGHT',FGCOLOR = CALC.GRAY82,}
CALC.ui.CLOSE = iup.stationbutton {title = 'Close', 
  EXPAND='YES',BGCOLOR=CALC.CLOSE_COLORBG,FGCOLOR=CALC.CLOSE_COLORFG}
CALC.ui.MEMORY_CLEAR = iup.stationbutton {title = 'MC',
  EXPAND='VERTICAL',BGCOLOR=CALC.MEMORY_COLORBG,FGCOLOR=CALC.MEMORY_COLORFG}
CALC.ui.MEMORY_ADD = iup.stationbutton {title = 'M+',
  EXPAND='VERTICAL',BGCOLOR=CALC.MEMORY_COLORBG,FGCOLOR=CALC.MEMORY_COLORFG}
CALC.ui.MEMORY_RECALL = iup.stationbutton {title = 'MR',
  EXPAND='VERTICAL',BGCOLOR=CALC.MEMORY_COLORBG,FGCOLOR=CALC.MEMORY_COLORFG}
CALC.ui.MEMORY_DIALOG = iup.text {value = '',
  EXPAND='YES',ALIGNMENT='ACENTER',READONLY='YES',BGCOLOR = CALC.GRAY82,FGCOLOR=CALC.BLACK}

--operands
CALC.ui.CLEAR_ALL = iup.stationbutton {title = 'C',
  BGCOLOR=CALC.CLEAR_COLORBG, FGCOLOR=CALC.CLEAR_COLORFG,EXPAND='YES'}
CALC.ui.CLEAR_ENTRY = iup.stationbutton {title = 'CE',
  BGCOLOR=CALC.CLEAR_COLORBG, FGCOLOR=CALC.CLEAR_COLORFG,EXPAND='YES'}
CALC.ui.EQUAL = iup.stationbutton {title = '=', 
  BGCOLOR=CALC.EQUAL_COLORBG, FGCOLOR=CALC.EQUAL_COLORFG,SIZE='50X150',
  EXPAND='VERTICAL'}
CALC.ui.ADD = iup.stationbutton {title = '+',
  BGCOLOR=CALC.OPERAND_COLORBG,FGCOLOR=CALC.OPERAND_COLORFG,SIZE='50'}
CALC.ui.MINUS = iup.stationbutton {title = '-',
  BGCOLOR=CALC.OPERAND_COLORBG,FGCOLOR=CALC.OPERAND_COLORFG,SIZE='50',}
CALC.ui.MULTIPLY = iup.stationbutton {title = '*',
  BGCOLOR=CALC.OPERAND_COLORBG,FGCOLOR=CALC.OPERAND_COLORFG,SIZE='50',}
CALC.ui.DIVIDE = iup.stationbutton {title = '/',
  BGCOLOR=CALC.OPERAND_COLORBG,FGCOLOR=CALC.OPERAND_COLORFG,SIZE='50',}
CALC.ui.PERCENT = iup.stationbutton {title = '%',
  BGCOLOR=CALC.OPERAND_COLORBG,FGCOLOR=CALC.OPERAND_COLORFG,SIZE='50',}


-- functions 
CALC.ui.ONE_OVER = iup.stationbutton {title = '1/x',
  EXPAND='YES',BGCOLOR=CALC.FUNCTION_COLORBG, FGCOLOR=CALC.FUNCTION_COLORFG}
CALC.ui.BS =  iup.stationbutton {title = '<-',
  BGCOLOR=CALC.BS_COLORBG, FGCOLOR=CALC.BS_COLORFG,SIZE='50',EXPAND='VERTICAL'}
CALC.ui.RANDOM = iup.stationbutton {title = 'Random',
  BGCOLOR=CALC.FUNCTION_COLORBG, FGCOLOR=CALC.FUNCTION_COLORFG,EXPAND='YES'}
CALC.ui.SQRT = iup.stationbutton {title = 'SQRT',
  EXPAND='YES',BGCOLOR=CALC.FUNCTION_COLORBG, FGCOLOR=CALC.FUNCTION_COLORFG}
CALC.ui.RAISEY = iup.stationbutton {title = 'x^y',
  EXPAND='YES',BGCOLOR=CALC.FUNCTION_COLORBG, FGCOLOR=CALC.FUNCTION_COLORFG}
CALC.ui.RAISE2 = iup.stationbutton {title = 'x^2',
  EXPAND='YES',BGCOLOR=CALC.FUNCTION_COLORBG, FGCOLOR=CALC.FUNCTION_COLORFG}
CALC.ui.RAISE3 = iup.stationbutton {title = 'x^3',
  EXPAND='YES',BGCOLOR=CALC.FUNCTION_COLORBG, FGCOLOR=CALC.FUNCTION_COLORFG}
CALC.ui.SIN = iup.stationbutton {title = 'SIN',
  EXPAND='YES',BGCOLOR=CALC.SCI_COLORBG,FBCOLOR=CALC.SCI_COLORFG,}
CALC.ui.COS = iup.stationbutton {title = 'COS',
  EXPAND='YES',BGCOLOR=CALC.SCI_COLORBG,FBCOLOR=CALC.SCI_COLORFG,}
CALC.ui.TAN = iup.stationbutton {title = 'TAN',
  EXPAND='YES',BGCOLOR=CALC.SCI_COLORBG,FBCOLOR=CALC.SCI_COLORFG,}
CALC.ui.EXP = iup.stationbutton {title = 'EXP',
  EXPAND='YES',BGCOLOR=CALC.SCI_COLORBG,FBCOLOR=CALC.SCI_COLORFG,}
CALC.ui.LOG = iup.stationbutton {title = 'LOG',
  EXPAND='YES',BGCOLOR=CALC.SCI_COLORBG,FBCOLOR=CALC.SCI_COLORFG,}
CALC.ui.LOG10 = iup.stationbutton {title = 'LOG10',
  EXPAND='YES',BGCOLOR=CALC.SCI_COLORBG,FBCOLOR=CALC.SCI_COLORFG,}

CALC.ui.INV = iup.stationtoggle {title=CALC.TXTBLACK..'INV',}
CALC.ui.HYP = iup.stationtoggle {title=CALC.TXTBLACK..'HYP',}
CALC.ui.RAD = iup.stationtoggle {title=CALC.TXTBLACK..'Radians',}
CALC.ui.DEG = iup.stationtoggle {title=CALC.TXTBLACK..'Degrees',}

--0-9, misc
--CALC.ui.NUM  = {}
CALC.ui.NUM1 = iup.stationbutton {title = ' 1 ',
  EXPAND='YES',BGCOLOR=CALC.NUMBER_COLORBG,FBCOLOR=CALC.NUMBER_COLORFG,}
CALC.ui.NUM2 = iup.stationbutton {title = ' 2 ',
  EXPAND='YES',BGCOLOR=CALC.NUMBER_COLORBG,FBCOLOR=CALC.NUMBER_COLORFG,}
CALC.ui.NUM3 = iup.stationbutton {title = ' 3 ',
  EXPAND='YES',BGCOLOR=CALC.NUMBER_COLORBG,FBCOLOR=CALC.NUMBER_COLORFG,}
CALC.ui.NUM4 = iup.stationbutton {title = ' 4 ',
  EXPAND='YES',BGCOLOR=CALC.NUMBER_COLORBG,FBCOLOR=CALC.NUMBER_COLORFG,}
CALC.ui.NUM5 = iup.stationbutton {title = ' 5 ',
  EXPAND='YES',BGCOLOR=CALC.NUMBER_COLORBG,FBCOLOR=CALC.NUMBER_COLORFG,}
CALC.ui.NUM6 = iup.stationbutton {title = ' 6 ',
  EXPAND='YES',BGCOLOR=CALC.NUMBER_COLORBG,FBCOLOR=CALC.NUMBER_COLORFG,}
CALC.ui.NUM7 = iup.stationbutton {title = ' 7 ',
  EXPAND='YES',BGCOLOR=CALC.NUMBER_COLORBG,FBCOLOR=CALC.NUMBER_COLORFG,}
CALC.ui.NUM8 = iup.stationbutton {title = ' 8 ',
  EXPAND='YES',BGCOLOR=CALC.NUMBER_COLORBG,FBCOLOR=CALC.NUMBER_COLORFG,}
CALC.ui.NUM9 = iup.stationbutton {title = ' 9 ',
  EXPAND='YES',BGCOLOR=CALC.NUMBER_COLORBG,FBCOLOR=CALC.NUMBER_COLORFG,}
CALC.ui.NUM0 = iup.stationbutton {title = ' 0 ',
  EXPAND='YES',BGCOLOR=CALC.NUMBER_COLORBG,FBCOLOR=CALC.NUMBER_COLORFG,}
CALC.ui.PERIOD = iup.stationbutton {title = ' . ',
  EXPAND='YES',BGCOLOR=CALC.OPERAND_COLORBG,FGCOLOR=CALC.OPERAND_COLORFG}
CALC.ui.PLUS_MINUS = iup.stationbutton {title = '-/+',
  EXPAND='YES',BGCOLOR=CALC.OPERAND_COLORBG,FGCOLOR=CALC.OPERAND_COLORFG}

-- end ui elements


-- display box
CALC.ui.MAIN = iup.dialog {
  iup.pdarootframe {
    iup.vbox{
      iup.hbox{iup.pdasubframebg{CALC.ui.DISPLAY,},MARGIN=40},
      iup.hbox {
        CALC.ui.INV,CALC.ui.HYP,
        iup.fill{},
        iup.radio {iup.hbox{CALC.ui.RAD,CALC.ui.DEG,},};
      ALIGNMENT='ACENTER',VALUE=CALC.ui.DEG,},
      iup.hbox {CALC.ui.SIN, CALC.ui.COS, CALC.ui.TAN,GAP=2},
      iup.hbox {CALC.ui.EXP, CALC.ui.LOG, CALC.ui.LOG10,CALC.ui.SQRT,GAP=2},
      iup.hbox {CALC.ui.RAISEY, CALC.ui.RAISE2, CALC.ui.RAISE3,CALC.ui.ONE_OVER,GAP=2},
      iup.hbox {CALC.ui.RANDOM,iup.fill{},CALC.ui.CLEAR_ALL, CALC.ui.CLEAR_ENTRY,GAP=2},
      iup.hbox { -- main button box
        iup.vbox { -- MEMORY
          iup.hbox{CALC.ui.MEMORY_DIALOG,ALIGNMENT='ARIGHT',},
          CALC.ui.MEMORY_CLEAR,
          CALC.ui.MEMORY_RECALL, CALC.ui.MEMORY_ADD,
        MARGIN=5,GAP=1},
        iup.vbox {CALC.ui.NUM7,CALC.ui.NUM4,CALC.ui.NUM1,CALC.ui.NUM0,GAP=1},
        iup.vbox {CALC.ui.NUM8,
          CALC.ui.NUM5,CALC.ui.NUM2,CALC.ui.PLUS_MINUS,GAP=1},
        iup.vbox {CALC.ui.NUM9,
          CALC.ui.NUM6,CALC.ui.NUM3,CALC.ui.PERIOD,
        GAP=1},
        iup.fill{},
        iup.vbox {CALC.ui.DIVIDE,CALC.ui.MULTIPLY,CALC.ui.MINUS,CALC.ui.ADD,GAP=2},
        iup.vbox {CALC.ui.PERCENT, CALC.ui.BS, CALC.ui.EQUAL,GAP=2},
      GAP=1,}, -- end hbox 
    iup.hbox { CALC.ui.CLOSE,},
    }, -- end main vbox
  }; -- end pdarootfrmae
  TITLE = 'Calculator '..CALC.Ver,
  BORDER = 'YES',
  TOPMOST = 'YES',
  RESIZE = 'NO',
  MAXBOX = 'NO',
  MINBOX = 'NO',
  MENUBOX = 'NO',
  MODAL = 'YES',
  FULLSCREEN = 'NO',
  EXPAND = 'NO',
  BGCOLOR = CALC.GRAY82,
  DEFAULTESC = CALC.ui.CLOSE,
  DEFAULTENTER = CALC.ui.EQUAL,
} -- end dialog box
-- end display box


-- functions
function do_number(number)
  if string.find(CALC.ui.DISPLAY.TITLE,'%.') == nil then
    if string.len(string.gsub(CALC.ui.DISPLAY.TITLE,',','')) == 14 then
      CALC.ui.DISPLAY.TITLE = 'Error'
    end
  end

  if CALC.ui.DISPLAY.TITLE ~= 'Error' then 
    if CALC.CLEAR_DISPLAY  then
      CALC.ui.DISPLAY.TITLE = '0'
      CALC.CLEAR_DISPLAY = false
    end
    if     number == 0 and CALC.ui.DISPLAY.TITLE == '0' then
    elseif number == 0 and CALC.ui.DISPLAY.TITLE ~= '0' then
      CALC.ui.DISPLAY.TITLE = CALC.mval(string.gsub(CALC.ui.DISPLAY.TITLE,',','')..number)
    elseif number == '.' and CALC.ui.DISPLAY.TITLE == '' then
      CALC.ui.DISPLAY.TITLE = '0.'
    elseif number == '.' then
      if string.find (CALC.ui.DISPLAY.TITLE,'%.') == nil then
        CALC.ui.DISPLAY.TITLE = CALC.ui.DISPLAY.TITLE..number
        CALC.CHANGED = true
      end    
    else
      local num = string.gsub(CALC.ui.DISPLAY.TITLE,',','')..number
      if string.find(CALC.ui.DISPLAY.TITLE,'%.') ~= nil then
        CALC.ui.DISPLAY.TITLE = CALC.mval(num)
        CALC.CHANGED = true
      else
        CALC.ui.DISPLAY.TITLE = CALC.mval(tonumber(num))
        CALC.CHANGED = true
      end
    end
  end
end -- end do_number


function CALC.ui.NUM1:action() do_number(1) end
function CALC.ui.NUM2:action() do_number(2) end
function CALC.ui.NUM3:action() do_number(3) end
function CALC.ui.NUM4:action() do_number(4) end
function CALC.ui.NUM5:action() do_number(5) end
function CALC.ui.NUM6:action() do_number(6) end
function CALC.ui.NUM7:action() do_number(7) end
function CALC.ui.NUM8:action() do_number(8) end
function CALC.ui.NUM9:action() do_number(9) end
function CALC.ui.NUM0:action() do_number(0) end
function CALC.ui.PERIOD:action() do_number('.') end


function CALC.ui.BS:action()
  --erase the last char in display
  local num = string.gsub(CALC.ui.DISPLAY.TITLE,',','')
  if string.len(num) > 1 then
    CALC.ui.DISPLAY.TITLE = CALC.mval(string.gsub(num,'.\$',''))
  elseif string.len(num) == 1 or 0 then
    CALC.ui.DISPLAY.TITLE = '0'
  end
end -- CALC.ui.BS:action()


function CALC.ui.SQRT:action()
  if CALC.ui.DISPLAY.TITLE ~= 'Error' then
    local num = string.gsub(CALC.ui.DISPLAY.TITLE,',','')
    CALC.ui.DISPLAY.TITLE = math.sqrt(num)
  end
end -- CALC.ui.SQRT:action()


-- sin, sinh, asin
function CALC.Do_Trig(REG, HYPERB, INV)
  if CALC.ui.DISPLAY.TITLE ~= 'Error' then
    if CALC.ui.INV.value == 'ON' then -- inverse
      if CALC.ui.RAD.value == 'ON' then
      --INV RAD XXX
        CALC.ui.DISPLAY.TITLE = CALC.mval(INV(tonumber(CALC.ui.DISPLAY.TITLE)))
      elseif CALC.ui.DEG.value == 'ON' then
        --INV DEG XXX
        CALC.ui.DISPLAY.TITLE = CALC.mval(math.deg(INV(tonumber(CALC.ui.DISPLAY.TITLE))))
      end -- end RAD/DEG INV
    elseif CALC.ui.HYP.value == 'ON' then -- hyperbolic / diabolic
      --HYP XXX
      CALC.ui.DISPLAY.TITLE = CALC.mval(HYPERB(tonumber(CALC.ui.DISPLAY.TITLE)))
    else -- plain sin/cos/tan
      if CALC.ui.RAD.value == 'ON' then
        --RAD XXX
        CALC.ui.DISPLAY.TITLE = CALC.mval(REG(tonumber(CALC.ui.DISPLAY.TITLE)))
      elseif CALC.ui.DEG.value == 'ON' then
        --DEG XXX
        CALC.ui.DISPLAY.TITLE = CALC.mval(REG(math.rad(tonumber(CALC.ui.DISPLAY.TITLE))))
      end -- end RAD/DEG regular
    end -- end INV/HYP/plain
    CALC.CLEAR_DISPLAY = true
  end -- if DISPLAY ~= error
end -- CALC.Do_Trig()


function CALC.ui.INV:action()
  CALC.ui.HYP.value = 'OFF'
end

function CALC.ui.HYP:action()
  CALC.ui.INV.value = 'OFF'
end

function CALC.ui.SIN:action() CALC.Do_Trig(math.sin, math.sinh, math.asin) end
function CALC.ui.COS:action() CALC.Do_Trig(math.cos, math.cosh, math.acos) end
function CALC.ui.TAN:action() CALC.Do_Trig(math.tan, math.tanh, math.atan) end


--fx = math.exp, math.log, math.log10
function CALC.Do_FX(fx)
  if CALC.ui.DISPLAY.TITLE ~= 'Error' then
    local num = string.gsub(CALC.ui.DISPLAY.TITLE,',','')
    CALC.ui.DISPLAY.TITLE = CALC.mval(fx(tonumber(num)))
  end
end


function CALC.ui.EXP:action()
  CALC.Do_FX(math.exp)
end


function CALC.ui.LOG:action()
  CALC.Do_FX(math.log)
end


function CALC.ui.LOG10:action()
  if CALC.ui.DISPLAY.TITLE ~= 'Error' then
    local num = string.gsub(CALC.ui.DISPLAY.TITLE,',','')
    if num < 0 or tonumber(num) == nil then
      CALC.ui.DISPLAY.TITLE = 'Error'
    else
      CALC.ui.DISPLAY.TITLE = CALC.mval(math.log10(tonumber(num)))
    end
  end
end



function CALC.ui.RAISE2:action()
  if CALC.ui.DISPLAY.TITLE ~= 'Error' then
    local num = string.gsub(CALC.ui.DISPLAY.TITLE,',','')
    CALC.ui.DISPLAY.TITLE = CALC.mval(math.pow(num,2))
  end
end


function CALC.ui.RAISE3:action()
  if CALC.ui.DISPLAY.TITLE ~= 'Error' then
    local num = string.gsub(CALC.ui.DISPLAY.TITLE,',','')
    CALC.ui.DISPLAY.TITLE = CALC.mval(math.pow(num,3))
  end
end


function CALC.ui.RANDOM:action()
  if CALC.ui.DISPLAY.TITLE ~= 'Error' then
    local num = tonumber((string.gsub(CALC.ui.DISPLAY.TITLE,',','')))
    if num ~= 0 and (string.len(num) < 10) then 
      CALC.ui.DISPLAY.TITLE = CALC.mval(math.random(math.ceil(num)))
    else
      CALC.ui.DISPLAY.TITLE = CALC.mval(math.random())
    end
  else
    CALC.ui.DISPLAY.TITLE = CALC.mval(math.random())
  end
end


function CALC.ui.PERCENT:action()
  if CALC.ui.DISPLAY.TITLE ~= 'Error' then
    local num = tonumber((string.gsub(CALC.ui.DISPLAY.TITLE,',','')))
    if num ~= nil then CALC.ui.DISPLAY.TITLE = CALC.mval(num/100) end
  end
end -- end CALC.ui.PERCENT()


function CALC.ui.ONE_OVER:action()
  if CALC.ui.DISPLAY.TITLE ~= 'Error' then
    local num = tonumber((string.gsub(CALC.ui.DISPLAY.TITLE,',','')))
    if num ~= nil then CALC.ui.DISPLAY.TITLE = CALC.mval(1/num) end
  end
end -- end CALC.ui.ONE_OVER()


function CALC.do_operand(operand)
  if CALC.CHANGED == true then 
    if CALC.OPERAND then CALC.ui.EQUAL:action() end
    CALC.OPERAND = operand
    CALC.CLEAR_DISPLAY = true 
    local num = string.gsub(CALC.ui.DISPLAY.TITLE,',','')
    if tonumber(num) ~= nil then
      CALC.A = tonumber(num)
    else
      CALC.ui.DISPLAY.TITLE = 'Error'
    end  
    CALC.CHANGED = false
  else
    CALC.OPERAND=operand
  end
end -- end CALC.do_operand()


function CALC.ui.ADD:action() CALC.do_operand('PLUS') end
function CALC.ui.MINUS:action() CALC.do_operand('MINUS') end
function CALC.ui.DIVIDE:action() CALC.do_operand('DIVIDE') end
function CALC.ui.MULTIPLY:action() CALC.do_operand('MULTIPLY') end
function CALC.ui.RAISEY:action() CALC.do_operand('POW') end


function CALC.ui.MEMORY_ADD:action()
  local comp = string.gsub(CALC.ui.DISPLAY.TITLE,',','')
  if tonumber(comp) then 
    CALC.MEMORY = CALC.MEMORY + tonumber(comp)
    CALC.ui.MEMORY_DIALOG.value = '    M'
  else
    CALC.ui.DISPLAY.TITLE = 'Error'
  end
end -- end CALC.ui.MEMORY_ADD()


function CALC.ui.MEMORY_RECALL:action()
  CALC.ui.DISPLAY.TITLE = CALC.mval(CALC.MEMORY)
end -- end CALC.ui.MEMORY_RECALL()


function CALC.ui.MEMORY_CLEAR:action()
  CALC.MEMORY = 0
  CALC.ui.MEMORY_DIALOG.value = ''
end -- end CALC.ui.MEMORY_CLEAR()


function CALC.ui.CLEAR_ALL:action()
  CALC.ui.DISPLAY.TITLE = '0'
  CALC.OPERAND = ''
  CALC.A = 0
  CALC.B = 0
end -- end CALC.ui.CLEAR_ALL()


function CALC.ui.CLEAR_ENTRY:action()
  CALC.ui.DISPLAY.TITLE = '0'
  CALC.CLEAR_DISPLAY = true
end -- end CALC.ui.CLEAR_ENTRY


function CALC.ui.EQUAL:action()
  if CALC.ui.DISPLAY.TITLE ~= 'Error' then
    local num
    CALC.CLEAR_DISPLAY = true
    CALC.B = tonumber(((string.gsub(CALC.ui.DISPLAY.TITLE,',',''))))
    if CALC.OPERAND == '' then CALC.OPERAND = 'PLUS' end
    if CALC.OPERAND == 'MINUS' then num = CALC.A - CALC.B end
    if CALC.OPERAND == 'PLUS' then num = CALC.A + CALC.B end
    if CALC.OPERAND == 'DIVIDE' then num = CALC.A / CALC.B end
    if CALC.OPERAND == 'MULTIPLY' then num = CALC.A * CALC.B end
    if CALC.OPERAND == 'POW' then num = math.pow(CALC.A,CALC.B) end
    CALC.OPERAND = ''
    CALC.catcher = num
    CALC.ui.DISPLAY.TITLE = CALC.mval(num)
  end
end -- end CALC.ui.EQUAL()


function CALC.ui.PLUS_MINUS:action()
  if CALC.ui.DISPLAY.TITLE ~= 'Error' then
    if string.match(CALC.ui.DISPLAY.TITLE,'-') == '-' then
      CALC.ui.DISPLAY.TITLE = string.gsub(CALC.ui.DISPLAY.TITLE,'-','')
    else
      CALC.ui.DISPLAY.TITLE = '-'..CALC.ui.DISPLAY.TITLE
    end
  end
end -- end CALC.ui.PLUS_MINUS()


-- return a comma value for numers
function CALC.mval(amount)
  local neg = false
  if tonumber(amount) == nil or string.find(amount,'IN') then
    return 'Error'
  end
  
  if tonumber(amount) < 0 then
    neg = true
    amount = string.gsub(amount,'-','')
  end    
  if amount then
    local substrings = {}
    local decimal = false
    
    if string.find(amount,'%.') then
      decimal = string.gsub(amount,'.*%.','')
      amount = string.gsub(amount,'%..*','')
    end      
    local rest = amount
    local result
    
    while string.len(rest) > 2 do
      local restlen = string.len(rest)
      table.insert(substrings, 1, string.sub(rest, restlen-2))
      rest = string.sub(rest, 1, restlen-3)
    end
    
    if string.len(rest) > 0 then table.insert(substrings, 1, rest) end
    for i,v in ipairs(substrings) do
      result = result and (result..","..v) or v
    end
    if decimal then
      result= result..'.'..decimal
    end
    if neg then 
      return '-'..result
    else
      return result
    end
  end
end -- end CALC.mval()
                                                               

function CALC.Credits()
  -- display credits/usage
  print('\
  USAGE: /calc\
  \
  Hot keys:\
  \t  # = number 0-9\
  \t* = multiply\
  \t+ = plus/equal\
  \tenter = equal\
  \t. = period\
  \t/ = divide\
  \t% = percent\
  \t- = minus\
  \t= - equal\
\
  \tBackspace = delete last digit on display\
  \ta = clear all\
  \te = clear entry\
  \tm = memory add\
  \tr = memory recall\
  \tc = memory clear\
  \tESC = closes program\
  \t\''..gkinterface.GetBindsForCommand('calc')[1] ..'\' = closes program\
  ')
  
end  -- end CALC.Credits()

function CALC.ui.CLOSE:action()
  CALC.ui.MAIN:hide()
end -- end CALC.ui.CLOSE()

function CALC.commands(data,args)
  if args then  
    CALC.Credits()
  else
    CALC.ui.DEG.value = 'ON'
    CALC.ui.MAIN:show()
    iup.SetFocus(CALC.ui.EQUAL)
  end -- if args
end -- CALC.commands()


function CALC.ui.MAIN:k_any(char)
  local command = gkinterface.GetCommandForKeyboardBind(char)
  if command == 'calc' then
    CALC.ui.MAIN:hide()
    return iup.IGNORE
  elseif char == iup.K_0 then CALC.ui.NUM0:action()
  elseif char == iup.K_1 then CALC.ui.NUM1:action()
  elseif char == iup.K_2 then CALC.ui.NUM2:action()
  elseif char == iup.K_3 then CALC.ui.NUM3:action()
  elseif char == iup.K_4 then CALC.ui.NUM4:action()
  elseif char == iup.K_5 then CALC.ui.NUM5:action()
  elseif char == iup.K_6 then CALC.ui.NUM6:action()
  elseif char == iup.K_7 then CALC.ui.NUM7:action()
  elseif char == iup.K_8 then CALC.ui.NUM8:action()
  elseif char == iup.K_9 then CALC.ui.NUM9:action()

  elseif char == iup.K_a then CALC.ui.CLEAR_ALL:action()
  elseif char == iup.K_e then CALC.ui.CLEAR_ENTRY:action()
  elseif char == iup.K_BS then CALC.ui.BS:action()
  elseif char == iup.K_asterisk then CALC.ui.MULTIPLY:action()
  elseif char == iup.K_plus then CALC.ui.ADD:action()
  elseif char == iup.K_period then CALC.ui.PERIOD:action()
  elseif char == iup.K_slash then CALC.ui.DIVIDE:action()
  elseif char == iup.K_percent then CALC.ui.PERCENT:action()
  elseif char == iup.K_minus then CALC.ui.MINUS:action()
  elseif char == iup.K_equal then CALC.ui.EQUAL:action()
  elseif char == iup.K_m then CALC.ui.MEMORY_ADD:action()
  elseif char == iup.K_r then CALC.ui.MEMORY_RECALL:action()
  elseif char == iup.K_c then CALC.ui.MEMORY_CLEAR:action()
  else
  end
  return iup.CONTINUE
end --CALC.ui.MAIN:k_any()

-- end functions

--register
RegisterUserCommand('calc',CALC.commands)